
# Screenshot

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **Integer** | screenshot ID | 
**status** | [**StatusEnum**](#StatusEnum) | status of the request: \&quot;in_queue\&quot;, \&quot;processing\&quot;, \&quot;finished\&quot;, \&quot;error\&quot;  | 
**error** | **String** | description of the problem that occurred |  [optional]
**priority** | **Integer** | priority given to the screenshot: high (1) to low (3) |  [optional]
**url** | **String** | original URL requested | 
**size** | [**SizeEnum**](#SizeEnum) | screenshot size requested |  [optional]
**width** | **Integer** | screenshot width |  [optional]
**height** | **Integer** | screenshot height |  [optional]
**finalUrl** | **String** | URL of the screenshot (redirections can occur) |  [optional]
**scale** | **Double** | image scale. Always 1 for desktop browsers; mobiles may change the scale (zoom in or zoom out) to fit the page on the screen |  [optional]
**instanceId** | **Integer** | instance ID used for the screenshot | 
**cost** | **Integer** | number of credits spent for the screenshot |  [optional]
**referer** | **String** | custom referrer used (see Custom POST Data, Referer and Cookie) |  [optional]
**postData** | **String** | POST data sent (see Custom POST Data, Referer and Cookie) |  [optional]
**cookie** | **String** | custom cookie used (see Custom POST Data, Referer and Cookie) |  [optional]
**delay** | **Integer** | number of seconds to wait after page load |  [optional]
**flashDelay** | **Integer** | number of seconds to wait after page load if Flash elements are present |  [optional]
**details** | **Integer** | level of details about the screenshot and the page |  [optional]
**script** | **String** | URL of optional javascript file executed after the page load event |  [optional]
**sharedUrl** | **String** | if the screenshot was shared, show the public URL |  [optional]


<a name="StatusEnum"></a>
## Enum: StatusEnum
Name | Value
---- | -----
IN_QUEUE | &quot;in_queue&quot;
PROCESSING | &quot;processing&quot;
FINISHED | &quot;finished&quot;
ERROR | &quot;error&quot;


<a name="SizeEnum"></a>
## Enum: SizeEnum
Name | Value
---- | -----
SCREEN | &quot;screen&quot;
PAGE | &quot;page&quot;



