/*
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Browser;
import io.swagger.client.model.Instance;
import io.swagger.client.model.Screenshot;
import java.util.ArrayList;
import java.util.List;

/**
 * Account
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2017-01-29T05:18:22.088Z")
public class Account {
  @SerializedName("balance")
  private Integer balance = null;

  @SerializedName("free_screenshots_left")
  private Integer freeScreenshotsLeft = null;

  @SerializedName("private_instances")
  private Integer privateInstances = null;

  @SerializedName("hosting_browshot")
  private Integer hostingBrowshot = null;

  @SerializedName("instances")
  private List<Instance> instances = new ArrayList<Instance>();

  @SerializedName("browsers")
  private List<Browser> browsers = new ArrayList<Browser>();

  @SerializedName("screenshots")
  private List<Screenshot> screenshots = new ArrayList<Screenshot>();

  public Account balance(Integer balance) {
    this.balance = balance;
    return this;
  }

   /**
   * number of credits left on your account
   * @return balance
  **/
  @ApiModelProperty(example = "null", required = true, value = "number of credits left on your account")
  public Integer getBalance() {
    return balance;
  }

  public void setBalance(Integer balance) {
    this.balance = balance;
  }

  public Account freeScreenshotsLeft(Integer freeScreenshotsLeft) {
    this.freeScreenshotsLeft = freeScreenshotsLeft;
    return this;
  }

   /**
   * number of free screenshots available for the current month
   * @return freeScreenshotsLeft
  **/
  @ApiModelProperty(example = "null", required = true, value = "number of free screenshots available for the current month")
  public Integer getFreeScreenshotsLeft() {
    return freeScreenshotsLeft;
  }

  public void setFreeScreenshotsLeft(Integer freeScreenshotsLeft) {
    this.freeScreenshotsLeft = freeScreenshotsLeft;
  }

  public Account privateInstances(Integer privateInstances) {
    this.privateInstances = privateInstances;
    return this;
  }

   /**
   * 1 is your account is authorized to create and use private instances, 0 otherwise (default)
   * minimum: 0
   * maximum: 1
   * @return privateInstances
  **/
  @ApiModelProperty(example = "null", required = true, value = "1 is your account is authorized to create and use private instances, 0 otherwise (default)")
  public Integer getPrivateInstances() {
    return privateInstances;
  }

  public void setPrivateInstances(Integer privateInstances) {
    this.privateInstances = privateInstances;
  }

  public Account hostingBrowshot(Integer hostingBrowshot) {
    this.hostingBrowshot = hostingBrowshot;
    return this;
  }

   /**
   * 1 is your account is authorized to request hosting on Browshot, 0 otherwise (default)
   * minimum: 0
   * maximum: 1
   * @return hostingBrowshot
  **/
  @ApiModelProperty(example = "null", required = true, value = "1 is your account is authorized to request hosting on Browshot, 0 otherwise (default)")
  public Integer getHostingBrowshot() {
    return hostingBrowshot;
  }

  public void setHostingBrowshot(Integer hostingBrowshot) {
    this.hostingBrowshot = hostingBrowshot;
  }

  public Account instances(List<Instance> instances) {
    this.instances = instances;
    return this;
  }

  public Account addInstancesItem(Instance instancesItem) {
    this.instances.add(instancesItem);
    return this;
  }

   /**
   * list of private instances as returned by /api/v1/instance/list
   * @return instances
  **/
  @ApiModelProperty(example = "null", value = "list of private instances as returned by /api/v1/instance/list")
  public List<Instance> getInstances() {
    return instances;
  }

  public void setInstances(List<Instance> instances) {
    this.instances = instances;
  }

  public Account browsers(List<Browser> browsers) {
    this.browsers = browsers;
    return this;
  }

  public Account addBrowsersItem(Browser browsersItem) {
    this.browsers.add(browsersItem);
    return this;
  }

   /**
   * list of custom browsers as returned by /api/v1/browser/list
   * @return browsers
  **/
  @ApiModelProperty(example = "null", value = "list of custom browsers as returned by /api/v1/browser/list")
  public List<Browser> getBrowsers() {
    return browsers;
  }

  public void setBrowsers(List<Browser> browsers) {
    this.browsers = browsers;
  }

  public Account screenshots(List<Screenshot> screenshots) {
    this.screenshots = screenshots;
    return this;
  }

  public Account addScreenshotsItem(Screenshot screenshotsItem) {
    this.screenshots.add(screenshotsItem);
    return this;
  }

   /**
   * list of 10 latest screenshots requests as returned by /api/v1/screenshot/list
   * @return screenshots
  **/
  @ApiModelProperty(example = "null", value = "list of 10 latest screenshots requests as returned by /api/v1/screenshot/list")
  public List<Screenshot> getScreenshots() {
    return screenshots;
  }

  public void setScreenshots(List<Screenshot> screenshots) {
    this.screenshots = screenshots;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Account account = (Account) o;
    return Objects.equals(this.balance, account.balance) &&
        Objects.equals(this.freeScreenshotsLeft, account.freeScreenshotsLeft) &&
        Objects.equals(this.privateInstances, account.privateInstances) &&
        Objects.equals(this.hostingBrowshot, account.hostingBrowshot) &&
        Objects.equals(this.instances, account.instances) &&
        Objects.equals(this.browsers, account.browsers) &&
        Objects.equals(this.screenshots, account.screenshots);
  }

  @Override
  public int hashCode() {
    return Objects.hash(balance, freeScreenshotsLeft, privateInstances, hostingBrowshot, instances, browsers, screenshots);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Account {\n");
    
    sb.append("    balance: ").append(toIndentedString(balance)).append("\n");
    sb.append("    freeScreenshotsLeft: ").append(toIndentedString(freeScreenshotsLeft)).append("\n");
    sb.append("    privateInstances: ").append(toIndentedString(privateInstances)).append("\n");
    sb.append("    hostingBrowshot: ").append(toIndentedString(hostingBrowshot)).append("\n");
    sb.append("    instances: ").append(toIndentedString(instances)).append("\n");
    sb.append("    browsers: ").append(toIndentedString(browsers)).append("\n");
    sb.append("    screenshots: ").append(toIndentedString(screenshots)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

